drop database entitats;
create database entitats;
use entitats;

create table soci (numSoci integer auto_increment,nom varchar(10),cognom1 varchar(10),cognom2 varchar(10),
identificadorPersonal varchar(10) unique,adresa varchar(20),telefon integer(9),dataNaixement date,
dataAltaEntitat date,actiu tinyint(1) default '1',unique(nom,cognom1,cognom2),primary key (numSoci));

insert into soci(nom,cognom1,cognom2,identificadorPersonal,adresa,telefon,dataNaixement,dataAltaEntitat) values('Pere','Pau','Pi','11111111-F','Casa meva, 1, 1r 3a','999999999','1980-12-12','1992-12-12');

create table pesa (identificadorPesa integer auto_increment,nom varchar(30) UNIQUE,
durada time,procedencia varchar(15),autor varchar (20),dataCreacio date,descripcio text,
primary key(identificadorPesa));

insert into pesa(nom,durada,procedencia,autor,dataCreacio,descripcio) values('Festa major','00:12:00','Algun lloc','Desconegut','1952-12-12','No se');

create table actuacio (identificadorActuacio integer auto_increment,dataActuacio date,poblacio varchar(15),lloc varchar(30),horaInici time,observacions text,primary key(identificadorActuacio));

insert into actuacio(dataActuacio,poblacio,lloc,horaInici,observacions) values('2005-12-12','El meu poble','Ajuntament','00:13:34','Segur que plou');

CREATE TABLE pecesActuacio (actuacio_identificadorActuacio integer NOT NULL,
                      pesa_identificadorPesa integer NOT NULL,ordre integer NOT NULL,
                      PRIMARY KEY(actuacio_identificadorActuacio,pesa_identificadorPesa),
                      INDEX (actuacio_identificadorActuacio),
                      FOREIGN KEY (actuacio_identificadorActuacio)
                        REFERENCES actuacio(identificadorActuacio)
                        ON DELETE CASCADE,
                      INDEX (pesa_identificadorPesa),
                      FOREIGN KEY (pesa_identificadorPesa)
                        REFERENCES pesa(identificadorPesa)
			ON DELETE CASCADE
			);

CREATE TABLE usuariAplicacio (usuari varchar(10) NOT NULL UNIQUE,
contrasenya varchar(10) NOT NULL,nivell integer NOT NULL,
PRIMARY KEY(usuari,contrasenya)); 

insert into usuariAplicacio(usuari,contrasenya,nivell) values ('sgec','123456','3');

CREATE TABLE registreConnexions (usuari varchar(10),dataConnexio date,horaConnexio time,
				FOREIGN KEY (usuari)
				REFERENCES usuariAplicacio(usuari)
				ON UPDATE CASCADE ON DELETE CASCADE);

create table propostaModificacio (identificadorProposta integer auto_increment,numSoci integer NOT NULL,nom varchar(10),cognom1 varchar(10),cognom2 varchar(10),
identificadorPersonal varchar(10),adresa varchar(20),telefon integer(9) default 0,dataNaixement date default NULL,actiu tinyint(1) default 1,primary key (identificadorProposta));

CREATE TABLE participant (numSoci integer(10) NOT NULL UNIQUE,
 dataAltaParticipant date, PRIMARY KEY(numSoci), 
                        FOREIGN KEY (numSoci)
				REFERENCES soci(numSoci)
				ON UPDATE CASCADE ON DELETE CASCADE); 

insert into participant(numSoci,dataAltaParticipant) values('1','1992-12-12');

CREATE TABLE participantsActuacio (actuacio_identificadorActuacio integer NOT NULL,
                      participant_numSoci integer NOT NULL,ordre integer NOT NULL,
                      PRIMARY KEY(actuacio_identificadorActuacio,participant_numSoci),
                      INDEX (actuacio_identificadorActuacio),
                      FOREIGN KEY (actuacio_identificadorActuacio)
                        REFERENCES actuacio(identificadorActuacio)
                        ON DELETE CASCADE,
                      INDEX (participant_numSoci),
                      FOREIGN KEY (participant_numSoci)
                        REFERENCES participant(numSoci)
			ON DELETE CASCADE
			);

CREATE TABLE imatge(numImatge integer auto_increment,ruta varchar(100),
                      PRIMARY KEY(numImatge)                       
                      );

insert into imatge(ruta) values('../Galeria/sample.jpg');

CREATE TABLE imatgesSoci(imatge_numImatge integer NOT NULL UNIQUE,soci_numSoci integer NOT NULL,
                      PRIMARY KEY(imatge_numImatge,soci_numSoci),
                      FOREIGN KEY (soci_numSoci)
                        REFERENCES soci(numSoci)
                        ON DELETE CASCADE, 
                      FOREIGN KEY (imatge_numImatge)
                        REFERENCES imatge(numImatge)
                        ON DELETE CASCADE                     
                      );

CREATE TABLE imatgesActuacio(imatge_numImatge integer NOT NULL,actuacio_identificadorActuacio integer NOT NULL,
                      PRIMARY KEY(imatge_numImatge,actuacio_identificadorActuacio),       
                      FOREIGN KEY (actuacio_identificadorActuacio)
                        REFERENCES actuacio(identificadorActuacio)
                        ON DELETE CASCADE,
                      FOREIGN KEY (imatge_numImatge)
                        REFERENCES imatge(numImatge)
                        ON DELETE CASCADE                      
                      );

CREATE TABLE imatgesPesa(imatge_numImatge integer NOT NULL,pesa_identificadorPesa integer NOT NULL,
                      PRIMARY KEY(imatge_numImatge,pesa_identificadorPesa),       
                      FOREIGN KEY (pesa_identificadorPesa)
                        REFERENCES pesa(identificadorPesa)
                        ON DELETE CASCADE,
                      FOREIGN KEY (imatge_numImatge)
                        REFERENCES imatge(numImatge)
                        ON DELETE CASCADE                      
                      );