   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Actuacio.Actuacio;
   import Entitats.Actuacio.RelacioActuacions;
   import Entitats.Participant.Participant;
   import Entitats.Participant.RelacioParticipants;
   import Entitats.Pesa.Pesa;
   import Entitats.Pesa.RelacioPeces;
   import Entitats.Persistencia.Llistat;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import java.util.Vector;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder crear una nova actuacio
*@author Jordi Moles i Blanco, Abril 2005
*/

   public class ControlAltaActuacio
   {
   
      private File docFile;
      private String nomFitxer;
      private AbaRenderer pantalla; 
      private String dataActuacio,poblacioActuacio,llocActuacio,horaActuacio,observacionsActuacio;
      private boolean altaSenseProblemes;
      private JSSComboBox peces,participants;
      private JList llistaRepertori,llistaParticipants;
      private Vector elementsLlista,elementsLlistaParticipants;
      private Llistat participantsTemp; 
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre afegir actuacions al sistema. 
   */
      public ControlAltaActuacio()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_altaActuacio.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile=null;
         elementsLlista = new Vector();
         elementsLlistaParticipants = new Vector();
         participantsTemp = new Llistat();
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlAltaActuacio()
      {
      
         pantalla=null;
         elementsLlista.removeAllElements();
         elementsLlistaParticipants.removeAllElements();
         participantsTemp.destructorLlistat();
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaAltaActuacio()
      {
      
         JButton acceptar,cancelar,afegirRepertori,eliminarRepertori,afegirParticipants,eliminarParticipants;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
            RelacioPeces rp = new RelacioPeces();
            rp.obteTotesLesPeces();
         
            peces = (JSSComboBox)(pantalla.getObject("peces"));
         
            Pesa pesa = new Pesa();
         
            while(rp.hiHaPeces())
            {
            
               pesa = rp.obtePesa();
               peces.addItem(pesa.obteNom(),pesa.obteIdentificador());
            
            }
         
            peces.setSelectedValue((long)0);
         
            pesa.destructorPesa();	
            rp.destructorRelacioPeces();
         
            RelacioParticipants rpa = new RelacioParticipants();
            rpa.obteTotsElsParticipants();
            participants = (JSSComboBox)(pantalla.getObject("participants"));
            Participant participant = new Participant();
            while(rpa.hiHaParticipants())
            {
               participant = rpa.obteParticipant();
               participants.addItem(participant.obteCognom1()+" "+participant.obteCognom2()+" ,"+participant.obteNom(),participant.obteNumSoci());
            }
            participants.setSelectedValue((long)0);
            participant.destructorParticipant();
            rpa.destructorRelacioParticipants();
         
            llistaRepertori = (JList)(pantalla.getObject("llistaRepertori"));
            llistaParticipants = (JList)(pantalla.getObject("llistaParticipants"));
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaNovesDades();
                                          if(altaSenseProblemes)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("altaActuacio"))).dispose();
                                             Actuacio actuacio = new Actuacio();
                                             actuacio.estableixData(dataActuacio);
                                             actuacio.estableixPoblacio(poblacioActuacio);
                                             actuacio.estableixLloc(llocActuacio);
                                             actuacio.estableixHoraInici(horaActuacio);
                                             actuacio.estableixObservacions(observacionsActuacio);
                                          
                                             int valorIntIDActuacio=RelacioActuacions.afegirActuacio(actuacio);
                                          
                                             actuacio.estableixIdentificador(valorIntIDActuacio);
                                          
                                             Llistat llistatPecesActuacio = new Llistat(elementsLlista);
                                             ObjectePersistencia ope = new ObjectePersistencia();
                                             RelacioPeces rlp = new RelacioPeces();
                                          
                                             while(llistatPecesActuacio.hiHaElements())
                                             {
                                             
                                                ope.afegirCampText("nom",(String)llistatPecesActuacio.obtePrimerElement());
                                             
                                                rlp.obtePesaPerMultiplesCamps(ope);
                                             
                                                while(rlp.hiHaPeces())
                                                {
                                                
                                                   actuacio.afegeixPesa(rlp.obtePesa().obteIdentificador());
                                                
                                                }
                                             
                                                ope.destructorObjectePersistencia();
                                                ope = new ObjectePersistencia();
                                             
                                             }
                                          
                                             Llistat llistatParticipantsActuacio = new Llistat(elementsLlistaParticipants);
                                             ObjectePersistencia oper = new ObjectePersistencia();
                                             RelacioParticipants rlpa = new RelacioParticipants();
                                          
                                             while(llistatParticipantsActuacio.hiHaElements())
                                             {
                                             
                                                oper.afegirCampText("nom",(String)llistatParticipantsActuacio.obtePrimerElement());
                                             
                                                rlpa.obteParticipantPerMultiplesCamps(oper);
                                             
                                                while(rlp.hiHaPeces())
                                                {
                                                
                                                   actuacio.afegeixPesa(rlp.obtePesa().obteIdentificador());
                                                
                                                }
                                             
                                                oper.destructorObjectePersistencia();
                                                oper = new ObjectePersistencia();
                                             
                                             }
                                          
                                             for(int i = 0;i<participantsTemp.quants();i++)
                                             {
                                                if((String)participantsTemp.obteElement(i)!="" & (String)participantsTemp.obteElement(i)!=" ")
                                                {
                                                   actuacio.afegeixParticipant(i);
                                                }
                                             }
                                          
                                             File docFile4 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                             String nomFitxer4 = docFile4.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                pantalla4.load();
                                                pantalla4.renderInterface();
                                             
                                                   ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
                                                acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                        new ActionListener()    
                                                                        {
                                                                        
                                                                           public void actionPerformed(ActionEvent ae) 
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla4.getObject("operacioOK"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                                catch(Exception e) {   
                                                
                                                   System.err.println("(ControlAltaActuacio1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             actuacio.destructorActuacio();
                                             docFile4=null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("altaActuacio"))).dispose();
                                       
                                       }
                                    
                                    });
         
         									///////////BOTO AFEGIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
            afegirRepertori=(JButton)(pantalla.getObject("afegirRepertori"));
         
            afegirRepertori.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          long seleccio = ((JSSComboBox)pantalla.getObject("peces")).getSelectedValue();
                                          Pesa Pesa = RelacioPeces.obtePesaPerIdentificadorPesa((int)seleccio);	
                                          if(!elementsLlista.contains(Pesa.obteNom()))
                                             elementsLlista.add(Pesa.obteNom());
                                          Pesa.destructorPesa();
                                          llistaRepertori.setListData(elementsLlista);
                                       
                                       }
                                    
                                    });
         
         									///////////BOTO ELIMINAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
            eliminarRepertori=(JButton)(pantalla.getObject("eliminarRepertori"));
         
            eliminarRepertori.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          int seleccio = ((JList)pantalla.getObject("llistaRepertori")).getSelectedIndex();
                                          if(seleccio>=0)
                                          {
                                             elementsLlista.removeElementAt(seleccio);
                                             llistaRepertori.setListData(elementsLlista);
                                          }
                                       
                                       }
                                    
                                    });
         
            afegirParticipants=(JButton)(pantalla.getObject("afegirParticipants"));
         
            afegirParticipants.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          long seleccio = ((JSSComboBox)pantalla.getObject("participants")).getSelectedValue();
                                          Participant Participant = RelacioParticipants.obteParticipantPerNumSoci((int)seleccio);	
                                       
                                          if(!elementsLlistaParticipants.contains(Participant.obteCognom1()+" "+Participant.obteCognom2()+" ,"+Participant.obteNom()))
                                          {
                                             elementsLlistaParticipants.add(Participant.obteCognom1()+" "+Participant.obteCognom2()+" ,"+Participant.obteNom());
                                             participantsTemp.afegeixAPosicio((String)(Participant.obteCognom1()+" "+Participant.obteCognom2()+" ,"+Participant.obteNom()),Participant.obteNumSoci());
                                          }
                                          Participant.destructorParticipant();
                                          llistaParticipants.setListData(elementsLlistaParticipants);
                                       
                                       }
                                    
                                    });
         
         									///////////BOTO ELIMINAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
            eliminarParticipants=(JButton)(pantalla.getObject("eliminarParticipants"));
         
            eliminarParticipants.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          int seleccio = ((JList)pantalla.getObject("llistaParticipants")).getSelectedIndex();
                                          if(seleccio>=0)
                                          {
                                             String valorAEliminar = (String)((JList)pantalla.getObject("llistaParticipants")).getSelectedValue();
                                             elementsLlistaParticipants.removeElementAt(seleccio);
                                             int posicio = participantsTemp.buscaElement(valorAEliminar);
                                             participantsTemp.eliminaElement(posicio);
                                             llistaParticipants.setListData(elementsLlistaParticipants);
                                          }
                                       
                                       }
                                    
                                    });									
         
         }
            catch(Exception e) {        
            
            
               System.err.println("(ControlAltaActuacio2)Error: " + e.getMessage());
            
            } 
      
      }
   
   
   /**
   * Metode que valida les dades entrades per a la nova actuacio
   */
      private void capturaIValidaNovesDades()
      {
      
         altaSenseProblemes = true;
         boolean entraData = true;
         boolean entraPoblacio = true; 
      
         dataActuacio=((JTextField)(pantalla.getObject("valorData"))).getText();
         poblacioActuacio=((JTextField)(pantalla.getObject("valorPoblacio"))).getText();
         llocActuacio=((JTextField)(pantalla.getObject("valorLloc"))).getText();
         horaActuacio=((JTextField)(pantalla.getObject("valorHora"))).getText();
         observacionsActuacio=((JTextArea)(pantalla.getObject("valorObservacions"))).getText();
      
         //validar dades
      
         if(dataActuacio.compareToIgnoreCase("")==0)
         { 
            altaSenseProblemes=false;
         }
         else
            if(!ValidadorFormulariEntrada.validaData(dataActuacio)) 
            {
               altaSenseProblemes=false;
            }
         if(poblacioActuacio.compareToIgnoreCase("")==0) 
         {
            altaSenseProblemes=false;
         }
         else 
            if(!ValidadorFormulariEntrada.validaNom(poblacioActuacio))
            { 
               altaSenseProblemes=false;
            }
      
         if(llocActuacio.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaNom(llocActuacio)) altaSenseProblemes=false;
         else
         {
            if(horaActuacio.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaHora(horaActuacio)) altaSenseProblemes=false;
            else
            {
               if(observacionsActuacio.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaDescripcio(observacionsActuacio)) altaSenseProblemes=false;
            
            }
         }
      
      
         if(altaSenseProblemes==false)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_error.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
            JLabel mis1,mis2;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
            
               pantalla2.load();
               pantalla2.renderInterface();
            
               mis1=(JLabel)(pantalla2.getObject("mis1"));
               mis2=(JLabel)(pantalla2.getObject("mis2"));
            
               mis1.setText("Dades incorrectes: La data i la poblacio son obligatories."); 
               mis2.setText("La data i la hora s'han d'introdur amb els formats entre parentesis");
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()    
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae) 
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("error"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlAltaActuacio3)Error: " + e.getMessage());
               
               }
         
            docFile2=null;
         
         }
      
      }
   
   }