   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import Entitats.Soci.Soci;
   import Entitats.Soci.RelacioSocis;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Eines.ImageFileView;
   import Entitats.Eines.ImageFilter;
   import Entitats.Eines.ImagePreview;
   import Entitats.Eines.Utils;
   import Entitats.Eines.CopiaFitxer;
   import Entitats.Eines.Fitxer;
   import Entitats.Eines.Cadena;
   import Entitats.Imatge.Imatge;
   import Entitats.Imatge.RelacioImatges;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder crear una nou soci
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlAltaSoci
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla; 
      String nomSoci,cognom1Soci,cognom2Soci,identificadorPersonalSoci,adresaSoci;
      String telefonSoci,dataNaixementSoci;
      boolean altaSenseProblemes;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre afegir socis al sistema. 
   */
      public ControlAltaSoci()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_altaSoci.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile=null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlAltaSoci()
      {
      
         pantalla=null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaAltaSoci()
      {
      
         JButton acceptar,cancelar,obrir,afegir;
      
         final Fitxer arxiu = new Fitxer();
         final Fitxer directoriDesti = new Fitxer();
         final Fitxer fitxerDesti = new Fitxer();
      
         final Cadena rutaImatge = new Cadena();
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          boolean noExisteixSoci=false;
                                          boolean noExisteixSociAmbNoms=false;
                                       
                                          capturaIValidaNovesDades();
                                          if(altaSenseProblemes && (noExisteixSoci=RelacioSocis.noExisteix(identificadorPersonalSoci)) && (noExisteixSociAmbNoms=RelacioSocis.noExisteixAmbNoms(nomSoci,cognom1Soci,cognom2Soci)))
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("altaSoci"))).dispose();
                                             Soci soci = new Soci();
                                             soci.estableixNom(nomSoci);
                                             soci.estableixCognom1(cognom1Soci);
                                             if(cognom2Soci.compareToIgnoreCase("")!=0) soci.estableixCognom2(cognom2Soci);
                                             soci.estableixIdentificadorPersonal(identificadorPersonalSoci);
                                             if(adresaSoci.compareToIgnoreCase("")!=0)soci.estableixAdresa(adresaSoci);
                                             if(telefonSoci.compareToIgnoreCase("")!=0)soci.estableixTelefon(Integer.parseInt(telefonSoci));
                                             if(dataNaixementSoci.compareToIgnoreCase("")!=0)soci.estableixDataNaixement(dataNaixementSoci);
                                             if(rutaImatge.obteCadena()!="")
                                             {
                                                RelacioImatges relIm = new RelacioImatges();
                                                Imatge imatge = new Imatge();
                                                imatge.estableixRuta(rutaImatge.obteCadena());
                                                soci.estableixImatge(relIm.afegirImatge(imatge));   
                                             }
                                          
                                          
                                             int valorIntNumSoci=RelacioSocis.afegirSoci(soci);
                                          
                                             File docFile4 = new File(".././GUI/SGEC_GUI_sociCreat.jar");
                                             String nomFitxer4 = docFile4.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                if(valorIntNumSoci>0)
                                                {
                                                
                                                   final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                   pantalla4.load();
                                                   pantalla4.renderInterface();
                                                   JTextField valorNumSoci;
                                                
                                                   valorNumSoci=(JTextField)(pantalla4.getObject("valorNumSoci"));
                                                   valorNumSoci.setText(""+valorIntNumSoci+"");
                                                   valorNumSoci.setEnabled(false);
                                                
                                                
                                                
                                                   ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
                                                   acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla4.getObject("sociCreat"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   valorNumSoci=null;
                                                
                                                }
                                             
                                             }
                                             
                                                catch(Exception e) {   
                                                
                                                   System.err.println("(ControlAltaSoci1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             soci.destructorSoci();
                                             docFile4=null;
                                          
                                          }
                                          else
                                          {
                                          
                                             if(altaSenseProblemes)
                                             {
                                             
                                                Soci soci;
                                             
                                                if(!noExisteixSoci)
                                                {
                                                   soci = RelacioSocis.obteSociPerIdentificadorPersonal(identificadorPersonalSoci); 
                                                }
                                                else
                                                { 
                                                   ObjectePersistencia o = new ObjectePersistencia();
                                                   o.afegirCampText("nom",nomSoci);
                                                   o.afegirCampText("cognom1",cognom1Soci);
                                                   o.afegirCampText("cognom2",cognom2Soci);
                                                
                                                   RelacioSocis relacioSocis = new RelacioSocis();
                                                   relacioSocis.obteSociPerMultiplesCamps(o);
                                                   soci = relacioSocis.obteSoci();
                                                }
                                             
                                                if(soci.esActiu())
                                                {
                                                
                                                   File docFile3 = new File(".././GUI/SGEC_GUI_sociExistent.jar");
                                                   String nomFitxer3 = docFile3.getAbsolutePath();
                                                   JButton acceptar;
                                                
                                                   try
                                                   {
                                                   
                                                      final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                      pantalla3.load();
                                                      pantalla3.renderInterface();
                                                   
                                                   ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
                                                      acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                   
                                                      acceptar.addActionListener(
                                                                           
                                                                           
                                                                              new ActionListener()    
                                                                              {
                                                                              
                                                                                 public void actionPerformed(ActionEvent ae) 
                                                                                 {
                                                                                 
                                                                                    ((JFrame)(pantalla3.getObject("sociExistent"))).dispose();
                                                                                 
                                                                                 }
                                                                              
                                                                              });
                                                   
                                                   
                                                   }
                                                   
                                                      catch(Exception e) {        
                                                      
                                                      
                                                         System.err.println("(ControlAltaSoci2)Error: " + e.getMessage());
                                                      
                                                      }
                                                
                                                   docFile3=null;
                                                
                                                }
                                                else
                                                {
                                                
                                                   ((JFrame)(pantalla.getObject("altaSoci"))).dispose();
                                                   ControlTornadaSoci cts = new ControlTornadaSoci();
                                                   cts.iniciaTornadaSoci(soci);
                                                   //cts.destructorControlTornadaSoci();
                                                
                                                }
                                             
                                                soci.destructorSoci();
                                             
                                             }
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("altaSoci"))).dispose();
                                       
                                       }
                                    
                                    });
         
               ///////////BOTO OBRIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
            obrir=(JButton)(pantalla.getObject("obre"));
         
            obrir.addActionListener(                                                        
                                 
                                    new ActionListener()                                                
                                    {                                  
                                    
                                       public void actionPerformed(ActionEvent ae)                                         
                                       {
                                       
                                          try
                                          {
                                          
                                             JFileChooser fc;
                                             fc = new JFileChooser();
                                          
                                             fc.addChoosableFileFilter(new ImageFilter());
                                             fc.setAcceptAllFileFilterUsed(false);
                                          
                                             fc.setFileView(new ImageFileView());
                                          
                                             fc.setAccessory(new ImagePreview(fc));
                                          
                                          
                                             int returnVal = fc.showDialog((JFrame)(pantalla.getObject("altaSoci")),"Afegir");
                                          
                                             if (returnVal == JFileChooser.APPROVE_OPTION) {
                                                File directori = fc.getCurrentDirectory();
                                                arxiu.estableixFitxer(fc.getSelectedFile());
                                                String fitxer = arxiu.obteFitxer().getName();
                                                ((JTextField)(pantalla.getObject("nomImatge"))).setText(fitxer);
                                             
                                                directoriDesti.estableixFitxer(new File("../Galeria/socis/imatges/"));
                                                fitxerDesti.estableixFitxer(new File(directoriDesti.obteFitxer(), arxiu.obteFitxer().getName()));
                                                rutaImatge.estableixCadena("../Galeria/socis/imatges/"+arxiu.obteFitxer().getName());
                                             
                                             } 
                                          
                                             fc.setSelectedFile(null);
                                          
                                          }
                                          
                                             catch(Exception e) {        
                                             
                                             
                                             
                                             
                                                System.err.println("(ControlAltaSoci3)Error: " + e.getMessage());
                                             
                                             }
                                       
                                       }
                                    
                                    });		
         
              ///////////BOTO AFEGIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
            afegir=(JButton)(pantalla.getObject("afegeix"));
         
            afegir.addActionListener(
                                 
                                    new ActionListener()    
                                    
                                    
                                    {
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae) 
                                       
                                       {
                                       
                                          try
                                          {
                                          
                                          
                                             if(arxiu.obteFitxer()!=null)
                                             {
                                                Long checksumSrc = CopiaFitxer.copia(arxiu.obteFitxer(), fitxerDesti.obteFitxer());
                                             
                                                Long checksumDest = CopiaFitxer.creaChecksum(fitxerDesti.obteFitxer());
                                                if (!checksumSrc.equals(checksumDest)) {
                                                   System.err.println("(ControlAltaSoci4)Error: La copia del fitxer "+arxiu.obteFitxer().getName()+" ha fallat");
                                                }
                                                else
                                                {
                                                
                                                   Image img = Toolkit.getDefaultToolkit().getImage(getClass().getResource(rutaImatge.obteCadena()));	
                                                   img = img.getScaledInstance(128,96,java.awt.Image.SCALE_SMOOTH); 
                                                
                                                   ((JButton)(pantalla.getObject("imatge"))).setIcon(new ImageIcon(img));
                                                
                                                } 
                                             }
                                             else throw new Exception ("Encara no has seleccionat cap fitxer!!");
                                          
                                          
                                          }
                                          
                                             catch(Exception e) {                                                     
                                             
                                                System.err.println("(ControlAltaSoci5)Error: " + e.getMessage());
                                             
                                             } 
                                       
                                       }
                                    
                                    });																							
         
         }
            catch(Exception e) {        
            
            
               System.err.println("(ControlAltaSoci6)Error: " + e.getMessage());
            
            } 
      
      }
   
      private void capturaIValidaNovesDades()
      {
      
         altaSenseProblemes = true;
      
         nomSoci=((JTextField)(pantalla.getObject("valorNom"))).getText();
         cognom1Soci=((JTextField)(pantalla.getObject("valorCognom1"))).getText();
         cognom2Soci=((JTextField)(pantalla.getObject("valorCognom2"))).getText();
         identificadorPersonalSoci=((JTextField)(pantalla.getObject("valorIdentificadorPersonal"))).getText();
         adresaSoci=((JTextField)(pantalla.getObject("valorAdresa"))).getText();
         telefonSoci=((JTextField)(pantalla.getObject("valorTelefon"))).getText();
         dataNaixementSoci=((JTextField)(pantalla.getObject("valorDataNaixement"))).getText();
      
         //validar dades
      
      
         if(nomSoci.compareToIgnoreCase("")==0)
         { 
            altaSenseProblemes=false;
         }
         else
            if(!ValidadorFormulariEntrada.validaNom(nomSoci)) 
            {
               altaSenseProblemes=false;
            }
      
         if(cognom1Soci.compareToIgnoreCase("")==0) 
         {
            altaSenseProblemes=false;
         }
         else 
            if(!ValidadorFormulariEntrada.validaNom(cognom1Soci))
            { 
               altaSenseProblemes=false;
            }
      
         if(identificadorPersonalSoci.compareToIgnoreCase("")==0) 
         {
            altaSenseProblemes=false;
         }
         else 
            if(!ValidadorFormulariEntrada.validaIdentificadorPersonal(identificadorPersonalSoci))
            { 
               altaSenseProblemes=false;
            }
      
         if(cognom2Soci.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaNom(cognom2Soci)) altaSenseProblemes=false;
         else
         {
            if(adresaSoci.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaAdresa(adresaSoci)) altaSenseProblemes=false;
            else
            {
               if(telefonSoci.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaTelefon(telefonSoci)) altaSenseProblemes=false;
               else
               {
                  if(dataNaixementSoci.compareToIgnoreCase("")!=0 & !ValidadorFormulariEntrada.validaData(dataNaixementSoci)) altaSenseProblemes=false;
               
               }
            }
         }
      
         if(altaSenseProblemes==false)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_error.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
            JLabel mis1,mis2;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
            
               pantalla2.load();
               pantalla2.renderInterface();
            
               mis1=(JLabel)(pantalla2.getObject("mis1"));
               mis2=(JLabel)(pantalla2.getObject("mis2"));
            
               mis1.setText("Dades incorrectes: Nom,primer cognom i identificador son obligatoris."); 
               mis2.setText("La data s'ha d'introdur amb el format entre parentesis");
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                    
                                    
                                       new ActionListener()    
                                       
                                       
                                       {
                                       
                                       
                                       
                                          public void actionPerformed(ActionEvent ae) 
                                          
                                          
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("error"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
            
            
               catch(Exception e) {        
               
               
               
                  System.err.println("(ControlAltaSoci7)Error: " + e.getMessage());
               
               }
         
            docFile2=null;
         
         }
      
      }
   
   }