   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Participant.Participant;
   import Entitats.Participant.RelacioParticipants;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Persistencia.Llistat;
   import Entitats.Soci.Soci;
   import Entitats.Soci.RelacioImatgesSoci;
   import Entitats.Imatge.Imatge;
   import Entitats.Imatge.RelacioImatges;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder consultar la info d'un participant del sistema
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlConsultaParticipant
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean consultaSenseProblemes;
      String nomParticipant,cognom1Participant,cognom2Participant,identificadorPersonalParticipant,adresaParticipant;
      String telefonParticipant,dataNaixementParticipant,numSoci,dataAltaParticipant;
      int campsBuits;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre consultar informacio sobre participants. 
   */
      public ControlConsultaParticipant()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_consultaParticipant.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlConsultaParticipant()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaConsultaParticipant()
      
      {
      
         JButton acceptar,cancelar;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                       
                                          if(consultaSenseProblemes && campsBuits<9)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("consultaParticipant"))).dispose();
                                          
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatParticipant.jar");
                                          
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                          
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                          
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                          
                                             String nomICognoms="";
                                             Participant participant = new Participant();
                                          
                                             JSSComboBox llistat;
                                          
                                             JButton acceptar,cancelar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(nomParticipant.compareToIgnoreCase("")!=0)op.afegirCampText("nom",nomParticipant);
                                                if(cognom1Participant.compareToIgnoreCase("")!=0)op.afegirCampText("cognom1",cognom1Participant);
                                                if(cognom2Participant.compareToIgnoreCase("")!=0)op.afegirCampText("cognom2",cognom2Participant);
                                                if(identificadorPersonalParticipant.compareToIgnoreCase("")!=0)op.afegirCampText("identificadorPersonal",identificadorPersonalParticipant);
                                                if(adresaParticipant.compareToIgnoreCase("")!=0)op.afegirCampText("adresa",adresaParticipant);
                                                if(telefonParticipant.compareToIgnoreCase("")!=0)op.afegirCampNumeric("telefon",Integer.parseInt(telefonParticipant));
                                                if(dataNaixementParticipant.compareToIgnoreCase("")!=0)op.afegirCampData("dataNaixement",dataNaixementParticipant);
                                                if(numSoci.compareToIgnoreCase("")!=0)op.afegirCampNumeric("numSoci",Integer.parseInt(numSoci));
                                                if(dataAltaParticipant.compareToIgnoreCase("")!=0)op.afegirCampData("dataAltaParticipant",dataAltaParticipant);
                                                RelacioParticipants relacioParticipants = new RelacioParticipants();
                                             
                                                relacioParticipants.obteParticipantPerMultiplesCamps(op);
                                             
                                             
                                                while(relacioParticipants.hiHaParticipants())
                                                {
                                                
                                                   nomICognoms="";
                                                
                                                   participant=relacioParticipants.obteParticipant();
                                                
                                                   if(participant.esActiu())
                                                   {
                                                      nomICognoms+=participant.obteCognom1()+" "+participant.obteCognom2()+" , "+participant.obteNom();
                                                      llistat.addItem(nomICognoms,participant.obteNumSoci());
                                                      elementsTrobats++;
                                                   }
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                   ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatParticipant"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 mostraParticipant((int)seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatParticipant"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                }
                                                else
                                                {
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatParticipant"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioParticipants.destructorRelacioParticipants();
                                                participant.destructorParticipant();
                                             
                                             
                                             }
                                             
                                                catch(Exception e) {      
                                                
                                                
                                                   System.err.println("(ControlConsultaParticipant1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("consultaParticipant"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
         
            catch(Exception e) {        
            
            
               System.err.println("(ControlConsultaParticipant2)Error: " + e.getMessage());
            
            }
      
      }
   
      private void capturaIValidaDades()
      {
      
         consultaSenseProblemes = true;
         campsBuits=0;
      
         JTextField nom,cognom1,cognom2,identificadorPersonal,adresa,telefon,dataNaixement,num,dataAlta;
      
         nom=(JTextField)(pantalla.getObject("valorNom"));
         nomParticipant=((JTextField)(pantalla.getObject("valorNom"))).getText();
         cognom1=(JTextField)(pantalla.getObject("valorCognom1"));
         cognom1Participant=((JTextField)(pantalla.getObject("valorCognom1"))).getText();
         cognom2=(JTextField)(pantalla.getObject("valorCognom2"));
         cognom2Participant=((JTextField)(pantalla.getObject("valorCognom2"))).getText();
         identificadorPersonal=(JTextField)(pantalla.getObject("valorIdentificadorPersonal"));
         identificadorPersonalParticipant=((JTextField)(pantalla.getObject("valorIdentificadorPersonal"))).getText();
         adresa=(JTextField)(pantalla.getObject("valorAdresa"));
         adresaParticipant=((JTextField)(pantalla.getObject("valorAdresa"))).getText();
         telefon=(JTextField)(pantalla.getObject("valorTelefon"));
         telefonParticipant=((JTextField)(pantalla.getObject("valorTelefon"))).getText();
         dataNaixement=(JTextField)(pantalla.getObject("valorDataNaixement"));
         dataNaixementParticipant=((JTextField)(pantalla.getObject("valorDataNaixement"))).getText();
         num=(JTextField)(pantalla.getObject("valorNumSoci"));
         numSoci=((JTextField)(pantalla.getObject("valorNumSoci"))).getText();
         dataAlta=(JTextField)(pantalla.getObject("valorDataAltaParticipant"));
         dataAltaParticipant=((JTextField)(pantalla.getObject("valorDataAltaParticipant"))).getText();
      
         if(nomParticipant.compareToIgnoreCase("")==0) campsBuits++;
         if(cognom1Participant.compareToIgnoreCase("")==0) campsBuits++;
         if(cognom2Participant.compareToIgnoreCase("")==0) campsBuits++;
         if(identificadorPersonalParticipant.compareToIgnoreCase("")==0) campsBuits++;
         if(adresaParticipant.compareToIgnoreCase("")==0) campsBuits++;
         if(telefonParticipant.compareToIgnoreCase("")==0) campsBuits++;
         if(dataNaixementParticipant.compareToIgnoreCase("")==0) campsBuits++;
         if(numSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(dataAltaParticipant.compareToIgnoreCase("")==0) campsBuits++;
      
      
         //validar dades
      
         if(nom.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomParticipant)) consultaSenseProblemes=false;
         else
         {
         
            if(cognom1.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom1Participant)) consultaSenseProblemes=false;
            else
            {
            
               if(cognom2.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom2Participant)) consultaSenseProblemes=false;
               else
               {
               
                  if(identificadorPersonal.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaIdentificadorPersonal(identificadorPersonalParticipant)) consultaSenseProblemes=false;
                  else
                  {
                  
                     if(adresa.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaAdresa(adresaParticipant)) consultaSenseProblemes=false;
                     else
                     {
                     
                        if(telefon.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaTelefon(telefonParticipant)) consultaSenseProblemes=false;
                        else
                        {
                        
                           if(dataNaixement.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataNaixementParticipant)) consultaSenseProblemes=false;
                           else
                           {
                           
                              if(num.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaXifra(numSoci)) consultaSenseProblemes=false;
                              else
                              {
                              
                                 if(dataAlta.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataAltaParticipant)) consultaSenseProblemes=false;
                              
                              }
                           }
                        }
                     
                     }
                  
                  }
               
               }
            
            }
         
         }
      
         if(consultaSenseProblemes==false | campsBuits==9)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlConsultaParticipant3)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
         else
         {
         
            if(campsBuits==8 && dataAlta.getText().compareToIgnoreCase("")!=0)
            {
               consultaSenseProblemes = false;
               File docFile21 = new File(".././GUI/SGEC_GUI_error.jar");
               String nomFitxer21 = docFile21.getAbsolutePath();
               JButton acceptar;
            
               try
               {
               
                  final AbaRenderer pantalla21 = new AbaRenderer(nomFitxer21, false, null);
                  pantalla21.load();
                  pantalla21.renderInterface();
               
                  JLabel mis1 =(JLabel)(pantalla21.getObject("mis1"));
                  mis1.setText("No es buscar pot nomes per el");
                  JLabel mis2 =(JLabel)(pantalla21.getObject("mis2"));
                  mis2.setText("camp \"Data Alta Participant\"");
               
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
                  acceptar=(JButton)(pantalla21.getObject("acceptar"));
               
                  acceptar.addActionListener(
                                       
                                       
                                       
                                          new ActionListener()                 
                                          
                                          
                                          {
                                          
                                          
                                          
                                             public void actionPerformed(ActionEvent ae)       
                                             
                                             
                                             {
                                             
                                                ((JFrame)(pantalla21.getObject("error"))).dispose();
                                             
                                             }
                                          
                                          });
               
               }
               
               
               
                  catch(Exception e) {        
                  
                  
                  
                     System.err.println("(ControlConsultaParticipant4)Error: " + e.getMessage());
                  
                  }
            
               docFile21 = null;
            
            }	
         }
      
      }
   
      private void mostraParticipant(final int numSoci)
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_resultatConsultaParticipant.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,modificar;
         JTextField camp;
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            Participant Participant = RelacioParticipants.obteParticipantPerNumSoci(numSoci);
         
            camp=(JTextField)(pantalla3.getObject("valorNom"));
            camp.setText(Participant.obteNom());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorCognom1"));
            camp.setText(Participant.obteCognom1());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorCognom2"));
            camp.setText(Participant.obteCognom2());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorIdentificadorPersonal"));
            camp.setText(Participant.obteIdentificadorPersonal());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorAdresa"));
            camp.setText(Participant.obteAdresa());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorTelefon"));
            camp.setText(""+Participant.obteTelefon()+"");
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDataNaixement"));
            camp.setText(Participant.obteDataNaixement());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorNumSoci"));
            camp.setText(""+numSoci+"");
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDataAltaParticipant"));
            camp.setText(Participant.obteDataAltaParticipant());
            camp.setEnabled(false);
         
            RelacioImatgesSoci rel = new RelacioImatgesSoci();
            rel.obteImatgesSoci(numSoci);
            Imatge imatge;
         
            if(rel.hiHaImatges())
            { 
            
               imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge());
               Image img = Toolkit.getDefaultToolkit().getImage(getClass().getResource(imatge.obteRuta()));	
               img = img.getScaledInstance(128,96,java.awt.Image.SCALE_SMOOTH); 
               ((JButton)(pantalla3.getObject("imatge"))).setIcon(new ImageIcon(img));
               ((JButton)(pantalla3.getObject("imatge"))).setText("");
            
            }
            else
            {
               ((JButton)(pantalla3.getObject("imatge"))).setText("No hi ha imatge");
            }
         
            rel.destructorRelacioImatgesSoci();
         
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("resultatConsultaParticipant"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlConsultaParticipant5)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   
   }