   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Soci.Soci;
   import Entitats.Soci.RelacioSocis;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Controladors.ControlAltaPropostaModificacioSoci;
   import Entitats.UsuariActual.UsuariActual;
   import Entitats.Soci.RelacioImatgesSoci;
   import Entitats.Imatge.RelacioImatges;
   import Entitats.Imatge.Imatge;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder consultar la info d'un soci del sistema
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlConsultaSoci
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      boolean consultaSenseProblemes;
      String nomSoci,cognom1Soci,cognom2Soci,identificadorPersonalSoci,adresaSoci;
      String telefonSoci,dataNaixementSoci,numSoci;
      int campsBuits;
      UsuariActual usuariActual;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre consultar informacio sobre socis. 
   */
      public ControlConsultaSoci()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_consultaSoci.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlConsultaSoci()
      {
      
         pantalla = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.
   */
      public void iniciaConsultaSoci(UsuariActual usuariActual)
      
      {
      
         JButton acceptar,cancelar;
         this.usuariActual = usuariActual;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
         	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          capturaIValidaDades();
                                          if(consultaSenseProblemes && campsBuits<8)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("consultaSoci"))).dispose();
                                          
                                             File docFile2 = new File(".././GUI/SGEC_GUI_llistatSoci.jar");
                                             String nomFitxer2 = docFile2.getAbsolutePath();
                                             File docFile3 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                             String nomFitxer3 = docFile3.getAbsolutePath();
                                             String nomICognoms="";
                                             Soci soci = new Soci();
                                             JSSComboBox llistat;
                                             JButton acceptar,cancelar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
                                                final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                int elementsTrobats=0;
                                                pantalla2.load();
                                                pantalla2.renderInterface();
                                                llistat = (JSSComboBox)pantalla2.getObject("llistat");
                                             
                                                ObjectePersistencia op = new ObjectePersistencia();
                                             
                                                if(nomSoci.compareToIgnoreCase("")!=0)op.afegirCampText("nom",nomSoci);
                                                if(cognom1Soci.compareToIgnoreCase("")!=0)op.afegirCampText("cognom1",cognom1Soci);
                                                if(cognom2Soci.compareToIgnoreCase("")!=0)op.afegirCampText("cognom2",cognom2Soci);
                                                if(identificadorPersonalSoci.compareToIgnoreCase("")!=0)op.afegirCampText("identificadorPersonal",identificadorPersonalSoci);
                                                if(adresaSoci.compareToIgnoreCase("")!=0)op.afegirCampText("adresa",adresaSoci);
                                                if(telefonSoci.compareToIgnoreCase("")!=0)op.afegirCampNumeric("telefon",Integer.parseInt(telefonSoci));
                                                if(dataNaixementSoci.compareToIgnoreCase("")!=0)op.afegirCampData("dataNaixement",dataNaixementSoci);
                                                if(numSoci.compareToIgnoreCase("")!=0)op.afegirCampNumeric("numSoci",Integer.parseInt(numSoci));
                                             
                                                RelacioSocis relacioSocis = new RelacioSocis();
                                                relacioSocis.obteSociPerMultiplesCamps(op);
                                             
                                                while(relacioSocis.hiHaSocis())
                                                {
                                                
                                                   nomICognoms="";
                                                   soci=relacioSocis.obteSoci();
                                                   if(soci.esActiu())
                                                   {
                                                      nomICognoms+=soci.obteCognom1()+" "+soci.obteCognom2()+" , "+soci.obteNom();
                                                      llistat.addItem(nomICognoms,soci.obteNumSoci());
                                                      elementsTrobats++;
                                                   }
                                                
                                                }
                                             
                                                llistat.setSelectedValue((long)0);
                                             
                                                op.destructorObjectePersistencia();
                                             
                                                if(elementsTrobats>0)
                                                {
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
                                                   acceptar=(JButton)(pantalla2.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatSoci"))).dispose();
                                                                                 long seleccio = ((JSSComboBox)pantalla2.getObject("llistat")).getSelectedValue();
                                                                                 mostraSoci((int)seleccio);
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   cancelar=(JButton)(pantalla2.getObject("cancelar"));
                                                
                                                   cancelar.addActionListener(
                                                                        
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla2.getObject("llistatSoci"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                   if(elementsTrobats==1)
                                                   {
                                                   
                                                      llistat.setSelectedValue((long)0);
                                                      acceptar.doClick();
                                                   
                                                   }
                                                
                                                }
                                                else
                                                {
                                                
                                                   ((JFrame)(pantalla2.getObject("llistatSoci"))).dispose();
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()    
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("noResultats"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                             
                                                relacioSocis.destructorRelacioSocis();
                                                soci.destructorSoci();
                                             
                                             
                                             }
                                             
                                                catch(Exception e) {      
                                                
                                                
                                                   System.err.println("(ControlConsultaSoci1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile2 = null;
                                             docFile3 = null;
                                             llistat = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCELAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                 
                                    new ActionListener()
                                    
                                    {
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("consultaSoci"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
         
            catch(Exception e) {        
            
            
               System.err.println("(ControlConsultaSoci2)Error: " + e.getMessage());
            
            }
      
      }
   
      public void iniciaConsultaSociLimitada(UsuariActual usuariActual) 
      {
      
         this.usuariActual = usuariActual;
      
         final String nomUsuariActual = usuariActual.usuariActual();
         final String passwordUsuariActual = usuariActual.identificador();
      
         File docFile2 = new File(".././GUI/SGEC_GUI_llistatSoci.jar");
         String nomFitxer2 = docFile2.getAbsolutePath();
         String nomICognoms="";
         Soci soci = new Soci();
         JSSComboBox llistat;
         JButton acceptar;
      
         try
         {
         
            final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
            int elementsTrobats=0;
            pantalla2.load();
            pantalla2.renderInterface();
            llistat = (JSSComboBox)pantalla2.getObject("llistat");
         
            acceptar=(JButton)(pantalla2.getObject("acceptar"));
         
            ObjectePersistencia op = new ObjectePersistencia();
         
            op.afegirCampText("nom",nomUsuariActual);
            op.afegirCampText("identificadorPersonal",passwordUsuariActual);
         
            RelacioSocis relacioSocis = new RelacioSocis();
            relacioSocis.obteSociPerMultiplesCamps(op);
         
            int NUMSOCI = 0; 
         
            if(relacioSocis.hiHaSocis())
            {
            
               nomICognoms="";
               soci=relacioSocis.obteSoci();
               if(soci.esActiu())
               {
                  nomICognoms+=soci.obteCognom1()+" "+soci.obteCognom2()+" , "+soci.obteNom();
                  llistat.addItem(nomICognoms,soci.obteNumSoci());
                  NUMSOCI=soci.obteNumSoci();
                  elementsTrobats++;
               }
               else
               {
               
                  System.err.println("(ControlConsultaSoci3)Aquest soci no esta actiu actualment.");
               
               }
            
            }
         
            llistat.setSelectedValue((long)0);
         
            op.destructorObjectePersistencia();
         
            if(elementsTrobats==1)
            {
            
               ((JFrame)(pantalla2.getObject("llistatSoci"))).dispose();
               mostraSoci((int)NUMSOCI);
            
            }
            else System.err.println("(ControlConsultaSoci4)Error al recuperar la informacio del soci.");
         
            relacioSocis.destructorRelacioSocis();
            soci.destructorSoci();
         
         }
         
            catch(Exception e) {      
            
            
            
               System.err.println("(ControlConsultaSoci5)Error: " + e.getMessage());
            
            }
      
         docFile2 = null;
         llistat = null;
      
      }
   
      private void capturaIValidaDades()
      {
      
         consultaSenseProblemes = true;
         campsBuits=0;
      
         JTextField nom,cognom1,cognom2,identificadorPersonal,adresa,telefon,dataNaixement,num;
      
         nom=(JTextField)(pantalla.getObject("valorNom"));
         nomSoci=((JTextField)(pantalla.getObject("valorNom"))).getText();
         cognom1=(JTextField)(pantalla.getObject("valorCognom1"));
         cognom1Soci=((JTextField)(pantalla.getObject("valorCognom1"))).getText();
         cognom2=(JTextField)(pantalla.getObject("valorCognom2"));
         cognom2Soci=((JTextField)(pantalla.getObject("valorCognom2"))).getText();
         identificadorPersonal=(JTextField)(pantalla.getObject("valorIdentificadorPersonal"));
         identificadorPersonalSoci=((JTextField)(pantalla.getObject("valorIdentificadorPersonal"))).getText();
         adresa=(JTextField)(pantalla.getObject("valorAdresa"));
         adresaSoci=((JTextField)(pantalla.getObject("valorAdresa"))).getText();
         telefon=(JTextField)(pantalla.getObject("valorTelefon"));
         telefonSoci=((JTextField)(pantalla.getObject("valorTelefon"))).getText();
         dataNaixement=(JTextField)(pantalla.getObject("valorDataNaixement"));
         dataNaixementSoci=((JTextField)(pantalla.getObject("valorDataNaixement"))).getText();
         num=(JTextField)(pantalla.getObject("valorNumSoci"));
         numSoci=((JTextField)(pantalla.getObject("valorNumSoci"))).getText();
      
         if(nomSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(cognom1Soci.compareToIgnoreCase("")==0) campsBuits++;
         if(cognom2Soci.compareToIgnoreCase("")==0) campsBuits++;
         if(identificadorPersonalSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(adresaSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(telefonSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(dataNaixementSoci.compareToIgnoreCase("")==0) campsBuits++;
         if(numSoci.compareToIgnoreCase("")==0) campsBuits++;
      
      
         //validar dades
      
         if(nom.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomSoci)) consultaSenseProblemes=false;
         else
         {
         
            if(cognom1.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom1Soci)) consultaSenseProblemes=false;
            else
            {
            
               if(cognom2.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom2Soci)) consultaSenseProblemes=false;
               else
               {
               
                  if(identificadorPersonal.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaIdentificadorPersonal(identificadorPersonalSoci)) consultaSenseProblemes=false;
                  else
                  {
                  
                     if(adresa.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaAdresa(adresaSoci)) consultaSenseProblemes=false;
                     else
                     {
                     
                        if(telefon.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaTelefon(telefonSoci)) consultaSenseProblemes=false;
                        else
                        {
                        
                           if(dataNaixement.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataNaixementSoci)) consultaSenseProblemes=false;
                           else
                           {
                           
                              if(num.getText().compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaXifra(numSoci)) consultaSenseProblemes=false;
                           
                           }
                        }
                     
                     }
                  
                  }
               
               }
            
            }
         
         }
      
         if(consultaSenseProblemes==false | campsBuits==8)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             ((JFrame)(pantalla2.getObject("dadesNoValides"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlConsultaSoci6)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         }
      
      }
   
      private void mostraSoci(final int numSoci)
      {
      
         File docFile3 = new File(".././GUI/SGEC_GUI_resultatConsultaSoci.jar");
         String nomFitxer3 = docFile3.getAbsolutePath();
         JButton acceptar,modificar;
         JTextField camp;
      
         try
         {
         
            final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
            pantalla3.load();
            pantalla3.renderInterface();
         
            Soci Soci = RelacioSocis.obteSociPerNumSoci(numSoci);
         
            camp=(JTextField)(pantalla3.getObject("valorNom"));
            camp.setText(Soci.obteNom());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorCognom1"));
            camp.setText(Soci.obteCognom1());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorCognom2"));
            camp.setText(Soci.obteCognom2());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorIdentificadorPersonal"));
            camp.setText(Soci.obteIdentificadorPersonal());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorAdresa"));
            camp.setText(Soci.obteAdresa());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorTelefon"));
            camp.setText(""+Soci.obteTelefon()+"");
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorDataNaixement"));
            camp.setText(Soci.obteDataNaixement());
            camp.setEnabled(false);
            camp=(JTextField)(pantalla3.getObject("valorNumSoci"));
            camp.setText(""+numSoci+"");
            camp.setEnabled(false);
         
            RelacioImatgesSoci rel = new RelacioImatgesSoci();
            rel.obteImatgesSoci(numSoci);
            Imatge imatge;
         
            if(rel.hiHaImatges())
            { 
            
               imatge = RelacioImatges.obteImatgePerIdentificadorImatge(rel.obteImatge());
               Image img = Toolkit.getDefaultToolkit().getImage(getClass().getResource(imatge.obteRuta()));	
               img = img.getScaledInstance(128,96,java.awt.Image.SCALE_SMOOTH); 
               ((JButton)(pantalla3.getObject("imatge"))).setIcon(new ImageIcon(img));
               ((JButton)(pantalla3.getObject("imatge"))).setText("");
            
            }
            else
            {
               ((JButton)(pantalla3.getObject("imatge"))).setText("No hi ha imatge");
            }
         
            rel.destructorRelacioImatgesSoci();
         
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
            acceptar=(JButton)(pantalla3.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()                 
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       {
                                       
                                          ((JFrame)(pantalla3.getObject("resultatConsultaSoci"))).dispose();
                                       
                                       }
                                    
                                    });
         
                        ///////////BOTO MODIFICAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  
            modificar=(JButton)(pantalla3.getObject("modificar"));
         
            modificar.addActionListener(
                                 
                                    new ActionListener()                        
                                    {                             
                                    
                                       public void actionPerformed(ActionEvent ae)                                               
                                       {
                                       
                                          ObjectePersistencia op = new ObjectePersistencia();
                                          boolean propostaAltaCorrecta;
                                       
                                          String nomSociModificat,cognom1SociModificat,cognom2SociModificat,identificadorPersonalSociModificat,adresaSociModificat;
                                          String telefonSociModificat,dataNaixementSociModificat;
                                       
                                          nomSociModificat=((JTextField)(pantalla3.getObject("valorNomModificat"))).getText();
                                          cognom1SociModificat=((JTextField)(pantalla3.getObject("valorCognom1Modificat"))).getText();
                                          cognom2SociModificat=((JTextField)(pantalla3.getObject("valorCognom2Modificat"))).getText();
                                          identificadorPersonalSociModificat=((JTextField)(pantalla3.getObject("valorIdentificadorPersonalModificat"))).getText();
                                          adresaSociModificat=((JTextField)(pantalla3.getObject("valorAdresaModificat"))).getText();
                                          telefonSociModificat=((JTextField)(pantalla3.getObject("valorTelefonModificat"))).getText();
                                          dataNaixementSociModificat=((JTextField)(pantalla3.getObject("valorDataNaixementModificat"))).getText();
                                       
                                          propostaAltaCorrecta=true;
                                          campsBuits=0;
                                       
                                          if(nomSociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(nomSociModificat)) {propostaAltaCorrecta=false;}
                                          else
                                          {
                                          
                                             if(cognom1SociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom1SociModificat)) {propostaAltaCorrecta=false;}
                                             else
                                             {
                                             
                                                if(cognom2SociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaNom(cognom2SociModificat)) {propostaAltaCorrecta=false;}
                                                {
                                                
                                                   if(identificadorPersonalSociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaIdentificadorPersonal(identificadorPersonalSociModificat)) {propostaAltaCorrecta=false;}
                                                   {
                                                   
                                                      if(adresaSociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaAdresa(adresaSociModificat)) {propostaAltaCorrecta=false;}
                                                      else
                                                      {
                                                      
                                                         if(telefonSociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaTelefon(telefonSociModificat)) {propostaAltaCorrecta=false;}
                                                         else
                                                         {
                                                         
                                                            if(dataNaixementSociModificat.compareToIgnoreCase("")!=0 && !ValidadorFormulariEntrada.validaData(dataNaixementSociModificat)) {propostaAltaCorrecta=false;}
                                                         
                                                         }
                                                      
                                                      }
                                                   
                                                   }
                                                
                                                }
                                             
                                             }
                                          
                                          }
                                       
                                          if(nomSociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(cognom1SociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(cognom2SociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(identificadorPersonalSociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(adresaSociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(telefonSociModificat.compareToIgnoreCase("")==0) campsBuits++;
                                          if(dataNaixementSociModificat.compareToIgnoreCase("")==0) campsBuits++; 
                                       
                                          if(propostaAltaCorrecta & campsBuits<7)
                                          {
                                          
                                             if( nomSociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("nom",nomSociModificat);
                                             if( cognom1SociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("cognom1",cognom1SociModificat);
                                             if( cognom2SociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("cognom2",cognom2SociModificat);
                                             if( identificadorPersonalSociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("identificadorPersonal",identificadorPersonalSociModificat);
                                             if( adresaSociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampText("adresa",adresaSociModificat);
                                             if( telefonSociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampNumeric("telefon",Integer.parseInt(telefonSociModificat));
                                             if( dataNaixementSociModificat.compareToIgnoreCase("")!=0 ) op.afegirCampData("dataNaixement",dataNaixementSociModificat);
                                             op.afegirCampNumeric("numSoci",numSoci);
                                          
                                             ControlAltaPropostaModificacioSoci capm = new ControlAltaPropostaModificacioSoci();
                                             propostaAltaCorrecta=capm.iniciaPropostaAltaModificacioSoci(usuariActual,op);
                                          
                                             ((JFrame)(pantalla3.getObject("resultatConsultaSoci"))).dispose();
                                          
                                             capm.destructorControlAltaPropostaModificacioSoci();
                                             op.destructorObjectePersistencia();
                                          
                                             if(propostaAltaCorrecta)
                                             {
                                             
                                                File docFile5 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
                                                String nomFitxer5 = docFile5.getAbsolutePath();
                                                JButton acceptar;
                                             
                                                try
                                                {
                                                
                                                   final AbaRenderer pantalla5 = new AbaRenderer(nomFitxer5, false, null);
                                                   pantalla5.load();
                                                   pantalla5.renderInterface();
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
                                                   acceptar=(JButton)(pantalla5.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                        
                                                                        
                                                                           new ActionListener()                 
                                                                           
                                                                           
                                                                           {
                                                                           
                                                                           
                                                                           
                                                                              public void actionPerformed(ActionEvent ae)       
                                                                              
                                                                              
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla5.getObject("operacioOK"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                                
                                                
                                                
                                                   catch(Exception e) {        
                                                   
                                                   
                                                   
                                                      System.err.println("(ControlConsultaSoci7)Error: " + e.getMessage());
                                                   
                                                   }
                                             
                                                docFile5 = null;
                                             
                                             }
                                          
                                          }
                                          else
                                          {
                                          
                                             File docFile4 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
                                             String nomFitxer4 = docFile4.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                pantalla4.load();
                                                pantalla4.renderInterface();
                                             
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
                                                acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                     
                                                                        new ActionListener()                            
                                                                        
                                                                        {
                                                                        
                                                                        
                                                                           public void actionPerformed(ActionEvent ae)                                        
                                                                           
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla4.getObject("dadesNoValides"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                             
                                                catch(Exception e) {        
                                                
                                                
                                                   System.err.println("(ControlConsultaSoci8)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile4 = null;
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlConsultaSoci9)Error: " + e.getMessage());
            
            }
      
         docFile3 = null;
         camp = null;
      
      }
   
   
   }