   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import Entitats.PropostaModificacioSoci.RelacioPropostesModificacioSoci;
   import Entitats.PropostaModificacioSoci.PropostaModificacioSoci;
   import Entitats.Persistencia.ObjectePersistencia;
   import java.util.Vector;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder tractar les peticions
* de modifacio de dades que s'han fet per part dels socis.
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlGestioPropostesModificacio
   {
   
      private File docFile;
      private String nomFitxer;
      private AbaRenderer pantalla;
      private JList llista;
      private Vector elementsLlista;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre gestionar les peticions. 
   */
      public ControlGestioPropostesModificacio()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_propostesModificacio.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile=null;
         elementsLlista = new Vector();
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlGestioPropostesModificacio()
      {
      
         pantalla=null;
         elementsLlista.removeAllElements();
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaGestioPropostesModificacio()
      {
      
         JButton sortir,descartar,aplicar;
      
         RelacioPropostesModificacioSoci Rpms = new RelacioPropostesModificacioSoci();
         Rpms.obteTotesLesPropostes();
         PropostaModificacioSoci Pms;
         String valorTextMostrat;
      
         while(Rpms.hiHaPropostes())
         {
         
            Pms = Rpms.obteProposta();
            if(Pms.esActiu())
            {
               valorTextMostrat="ID-Num.Soci:"+Pms.obteIdentificador()+"/"+Pms.obteNumSoci()+" Nom: "+Pms.obteNom()+" Cognom1: "+Pms.obteCognom1()+" Cognom2: "+Pms.obteCognom2()+" Identificador: "+Pms.obteIdentificadorPersonal()+" Adresa: "+Pms.obteAdresa()+" Telefon: "+Pms.obteTelefon()+" DNaixement: "+Pms.obteDataNaixement();
               if(!elementsLlista.contains(valorTextMostrat))
                  elementsLlista.add(valorTextMostrat);
            }
         
         }
      
         Rpms.destructorRelacioPropostesModificacioSoci();
         Pms=null;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
            llista=(JList)(pantalla.getObject("llista"));
            llista.setListData(elementsLlista);
         
            llista.setSelectedIndex(0);
         
         	///////////BOTO SORTIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            sortir=(JButton)(pantalla.getObject("sortir"));
         
            sortir.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("propostesModificacio"))).dispose();
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO DESCARTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            descartar=(JButton)(pantalla.getObject("descartar"));
         
            descartar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          String textMostrat = (String)(((JList)pantalla.getObject("llista")).getSelectedValue());
                                          int identificadorPropostaEscollit;
                                          int posicio1,posicio2;
                                       
                                          posicio1=textMostrat.indexOf(":");
                                          posicio1++;
                                          posicio2=textMostrat.indexOf("/",posicio1);
                                       
                                          identificadorPropostaEscollit=Integer.parseInt(textMostrat.substring(posicio1,posicio2));
                                       
                                          RelacioPropostesModificacioSoci.eliminarPropostaModificacioSociPerIdentificadorProposta(identificadorPropostaEscollit);
                                       
                                          elementsLlista.remove(textMostrat);
                                       
                                          llista.setListData(elementsLlista);
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO APLICAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
            aplicar=(JButton)(pantalla.getObject("aplicar"));
         
            aplicar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       
                                       {
                                       
                                          String textMostrat = (String)(((JList)pantalla.getObject("llista")).getSelectedValue());
                                          int identificadorPropostaEscollit;
                                          int posicio1,posicio2;
                                       
                                          posicio1=textMostrat.indexOf(":");
                                          posicio1++;
                                          posicio2=textMostrat.indexOf("/",posicio1);
                                       
                                          identificadorPropostaEscollit=Integer.parseInt(textMostrat.substring(posicio1,posicio2));
                                       
                                          RelacioPropostesModificacioSoci.confirmarPropostaModificacioSociPerIdentificadorProposta(identificadorPropostaEscollit);
                                       
                                          elementsLlista.remove(textMostrat);
                                       
                                          llista.setListData(elementsLlista);
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlGestioPropostesModificacio1)Error: " + e.getMessage());
            
            } 
      }
   
   }