   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import Entitats.UsuariAplicacio.RelacioUsuarisAplicacio;
   import Entitats.UsuariAplicacio.UsuariAplicacio;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import java.util.Vector;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder gestionar els usuaris
* que tenen acces al sistema.
*@author Jordi Moles i Blanco, Abril 2006
*/
   public class ControlGestioUsuarisAplicacio
   {
   
      private File docFile;
      private String nomFitxer;
      private AbaRenderer pantalla;
      private JList llista;
      private Vector elementsLlista;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre gestionar els usuaris del sistema. 
   */
      public ControlGestioUsuarisAplicacio()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_usuarisAplicacio.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile=null;
         elementsLlista = new Vector();
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlGestioUsuarisAplicacio()
      {
      
         pantalla=null;
         elementsLlista.removeAllElements();
         elementsLlista=null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaGestioUsuarisAplicacio()
      {
      
         JButton sortir,eliminar,afegir;
      
         RelacioUsuarisAplicacio Rua = new RelacioUsuarisAplicacio();
         Rua.obteTotsElsUsuaris();
         UsuariAplicacio usuariAplicacio;
         String valorTextMostrat;
      
         JSSComboBox llistatNivells;
      
         while(Rua.hiHaUsuaris())
         {
         
            usuariAplicacio = Rua.obteUsuari();
            valorTextMostrat="Usuari:"+usuariAplicacio.obteUsuari()+" / Nivell: "+usuariAplicacio.obteNivell();
            if(!elementsLlista.contains(valorTextMostrat))
               elementsLlista.add(valorTextMostrat);
         
         }
      
         Rua.destructorRelacioUsuarisAplicacio();
         usuariAplicacio = null;
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
            llistatNivells = (JSSComboBox)(pantalla.getObject("llistatNivell"));
         
            llistatNivells.addItem("Usuari Soci",1);
            llistatNivells.addItem("Usuari Repertori",2);
            llistatNivells.addItem("Secretari",3);
         
            llistatNivells.setSelectedValue((long)1);
         
            llista=(JList)(pantalla.getObject("llista"));
            llista.setListData(elementsLlista);
         
         	///////////BOTO SORTIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
            sortir=(JButton)(pantalla.getObject("sortir"));
         
            sortir.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("usuarisAplicacio"))).dispose();
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO ELIMINAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
            eliminar=(JButton)(pantalla.getObject("eliminar"));
         
            eliminar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          String textMostrat = (String)(((JList)pantalla.getObject("llista")).getSelectedValue());
                                          String nomUsuariEscollit;
                                          int posicio1,posicio2;
                                       
                                          posicio1=textMostrat.indexOf(":");
                                          posicio1++;
                                       
                                          posicio2=textMostrat.indexOf("/",posicio1);
                                          posicio2--;
                                       
                                          nomUsuariEscollit=textMostrat.substring(posicio1,posicio2);
                                       
                                          RelacioUsuarisAplicacio.eliminaUsuariActivitatPerNomUsuari(nomUsuariEscollit);
                                       
                                          elementsLlista.remove(textMostrat);
                                       
                                          llista.setListData(elementsLlista);
                                       
                                       }
                                    
                                    });
         
         	///////////BOTO AFEGIR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
            afegir=(JButton)(pantalla.getObject("afegir"));
         
            afegir.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          boolean altaUsuariSenseProblemes = true;
                                          String valorUsuari=((JTextField)(pantalla.getObject("valorUsuari"))).getText();
                                          String valorContrasenya=String.valueOf(((JPasswordField)(pantalla.getObject("valorContrasenya"))).getPassword());
                                       
                                          if(!ValidadorFormulariEntrada.validaNomUsuari(valorUsuari)) altaUsuariSenseProblemes = false;
                                          else
                                          {
                                          
                                             if(!ValidadorFormulariEntrada.validaContrasenya(valorContrasenya)) altaUsuariSenseProblemes = false;
                                          
                                          }
                                       
                                          if(altaUsuariSenseProblemes==false)
                                          {
                                          
                                             File docFile = new File(".././GUI/SGEC_GUI_nou_usuari.jar");
                                             String nomFitxer = docFile.getAbsolutePath();
                                             JButton acceptar;
                                          
                                             try
                                             {
                                             
                                                final AbaRenderer pantalla = new AbaRenderer(nomFitxer, false, null);
                                                pantalla.load();
                                                pantalla.renderInterface();
                                             
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
                                                acceptar=(JButton)(pantalla.getObject("acceptar"));
                                             
                                                acceptar.addActionListener(
                                                                     
                                                                     
                                                                        new ActionListener()    
                                                                        {
                                                                        
                                                                           public void actionPerformed(ActionEvent ae) 
                                                                           {
                                                                           
                                                                              ((JFrame)(pantalla.getObject("nou_usuari"))).dispose();
                                                                           
                                                                           }
                                                                        
                                                                        });
                                             
                                             }
                                             
                                             
                                                catch(Exception e) {        
                                                
                                                
                                                   System.err.println("(ControlGestioUsuarisAplicacio1)Error: " + e.getMessage());
                                                
                                                }
                                          
                                             docFile=null;
                                          
                                          }
                                          else
                                          {
                                          
                                             UsuariAplicacio usuariAplicacio = new UsuariAplicacio();
                                          
                                             usuariAplicacio.estableixUsuari(valorUsuari);
                                             usuariAplicacio.estableixContrasenya(valorContrasenya);
                                             int nivell = (int)(((JSSComboBox)pantalla.getObject("llistatNivell")).getSelectedValue());
                                             usuariAplicacio.estableixNivell(nivell);
                                          
                                             RelacioUsuarisAplicacio.afegirUsuariAplicacio(usuariAplicacio);
                                          
                                             String valorTextMostrat2="Usuari:"+valorUsuari+" / Nivell: "+nivell;
                                             if(!elementsLlista.contains(valorTextMostrat2))
                                                elementsLlista.add(valorTextMostrat2);
                                          
                                             llista.setListData(elementsLlista);
                                          
                                          }
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {        
            
               System.err.println("(ControlGestioUsuarisAplicacio2)Error: " + e.getMessage());
            
            } 
      }
   
   }