   package Entitats.Controladors;

   import Entitats.Persistencia.Persistencia;
   import Entitats.Persistencia.Resultat;
   import Entitats.Persistencia.ObjectePersistencia;
   import Entitats.Persistencia.Llistat;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import java.io.File;
   import Entitats.UsuariAplicacio.RelacioUsuarisAplicacio;
   import Entitats.UsuariActual.UsuariActual;
   import Entitats.UsuariAplicacio.RegistreConnexions;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder identificarse
* i en cas d'exit poder accedir a les zones bloquejades de l'aplicacio.
*@author Jordi Moles i Blanco, Abril 2005
*/
   public class ControlIdentificacio
   {
   
      private int[] nivellNecessari = {0,0,0,0,0};
      private UsuariActual usuariActual;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre a un usuari identificarse. 
   */
      public ControlIdentificacio(UsuariActual usuariActual)
      {
      
         this.usuariActual=usuariActual;
         for(int i = 0;i<5;i++) nivellNecessari[i]=0;
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlIdentificacio()
      {
      
         nivellNecessari = null;
         usuariActual = null;
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void identificaUsuari()
      {
      
         int[] i = {0,1,2,3,0};
         identificaUsuari(i);
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.
   *@param nivellNecessari taula amb els usuaris que poden loguejar-se en un moment determinat. Es a dir, per valid que sigui un login/password, si no pot entrar a una zona determinada l'autenticacio fallara.    
   */
      public void identificaUsuari(int []nivellNecessari)
      {
      
         for(int i = 0;i<5;i++) this.nivellNecessari[i] = nivellNecessari[i];
      
         JButton botoAcceptar,botoCancelar;
         String nomFitxer;
         File docFile = new File(".././GUI/SGEC_GUI_identificacio.jar");
         nomFitxer = docFile.getAbsolutePath();
      
         try
         {
         
            final AbaRenderer pantalla = new AbaRenderer(nomFitxer, true, null);
            pantalla.load();
            pantalla.renderInterface();	
         
         ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            botoAcceptar=(JButton)(pantalla.getObject("acceptar"));
         
            botoAcceptar.addActionListener(
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          botoAcceptar(pantalla);
                                       
                                       }
                                    
                                    });
         
         ///////////BOTO CANCEL.LAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
            botoCancelar=(JButton)(pantalla.getObject("cancelar"));
         
            botoCancelar.addActionListener(
                                 
                                    new ActionListener()
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae)
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("identificacio"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
            catch(Exception e) {
            
               System.err.println("(ControlIdentificacio1)Error Abacus: " + e.getMessage());
            
            } 
      
      }
   
      private void botoAcceptar(AbaRenderer pantalla)
      {
      
         JFrame finestra;
         JTextField valorUsuari;
         JPasswordField valorContrasenya;
      
         finestra=(JFrame)(pantalla.getObject("identificacio"));
         valorUsuari=(JTextField)(pantalla.getObject("valorUsuari"));
         valorContrasenya=(JPasswordField)(pantalla.getObject("valorContrasenya"));
      
         finestra.dispose();
      
         identificaUsuari(valorUsuari.getText(),String.valueOf(valorContrasenya.getPassword()));
      
      }
   
   
      private void identificaUsuari(String usuari,String contrasenya)
      {
      
         ObjectePersistencia op = new ObjectePersistencia();
         int i,j;
         JButton botoAcceptar;
         String nomFitxer;
         File docFile;
         int nivell;
         boolean siNivellNecessari=false;
         RelacioUsuarisAplicacio rua = new RelacioUsuarisAplicacio();
      
         op.afegirCampText("usuari",usuari);
         op.afegirCampText("contrasenya",contrasenya);
         rua.obteUsuariAplicacioPerMultiplesCamps(op);
      
         if(rua.hiHaUsuaris() | rua.esSoci(usuari,contrasenya)) 
         {
         
            if(rua.esSoci(usuari,contrasenya))
            {
               nivell = 0;
               siNivellNecessari=true;
            }
            else
            {
            
               nivell=rua.obteUsuari().obteNivell();
               j=0;
               while(j<5 && nivellNecessari[j]!=nivell) j++;
            
               if (j<5) siNivellNecessari=true;
            
            }
         
            if(siNivellNecessari)
            {
            
               RegistreConnexions.afegirRegistreConnexio(usuari);
               usuariActual.estableixNivell(nivell); 
               usuariActual.estableixUsuari(usuari);
               usuariActual.estableixIdentificador(contrasenya);
            
               docFile = new File(".././GUI/SGEC_GUI_usuariIdentificat.jar");
               nomFitxer = docFile.getAbsolutePath();
               try
               {
               
                  final AbaRenderer pantalla = new AbaRenderer(nomFitxer, true, null);
                  pantalla.load();
                  pantalla.renderInterface();	
               
                  JLabel textUsuari = (JLabel)(pantalla.getObject("info4"));
               
                  if(nivell==0)
                  {
                  
                     textUsuari.setText("SOCI");
                  
                  }
                  else
                  {
                  
                     if(nivell==1)
                     {
                     
                        textUsuari.setText("U.SOCI");	
                     
                     }
                     else
                     {
                     
                        if(nivell==2)
                        {
                        
                           textUsuari.setText("U.REPERTORI");	
                        
                        }
                        else
                        {
                        
                           if(nivell==3)
                           {
                           
                              textUsuari.setText("SECRETARI");	
                           
                           }
                        
                        }
                     
                     }
                  
                  }
               
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
                  botoAcceptar=(JButton)(pantalla.getObject("acceptar"));
               
                  botoAcceptar.addActionListener(
                                       
                                          new ActionListener()
                                          {
                                          
                                             public void actionPerformed(ActionEvent ae)
                                             {
                                             
                                                ((JFrame)(pantalla.getObject("usuariIdentificat"))).dispose();
                                             
                                             }
                                          
                                          });
               
               }
               
                  catch(Exception e) {
                  
                     System.err.println("(ControlIdentificacio2)Error Abacus: " + e.getMessage());
                  
                  }
            
            }
            else
            {
            
               docFile = new File(".././GUI/SGEC_GUI_insuficientIdentificacio.jar");
               nomFitxer = docFile.getAbsolutePath();
               try
               {
               
                  final AbaRenderer pantalla = new AbaRenderer(nomFitxer, true, null);
                  pantalla.load();
                  pantalla.renderInterface();	
               
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
                  botoAcceptar=(JButton)(pantalla.getObject("acceptar"));
               
                  botoAcceptar.addActionListener(
                                       
                                          new ActionListener()
                                          {
                                          
                                             public void actionPerformed(ActionEvent ae)
                                             
                                             {
                                             
                                                ((JFrame)(pantalla.getObject("insuficientIdentificacio"))).dispose();
                                             
                                             }
                                          
                                          });
               
               }
                  catch(Exception e) {
                  
                  
                     System.err.println("(ControlIdentificacio3)Error Abacus: " + e.getMessage());
                  
                  } 
            
            }
         
         }
         else
         {
         
            docFile = new File(".././GUI/SGEC_GUI_errorIdentificacio.jar");
            nomFitxer = docFile.getAbsolutePath();
            try
            {
            
               final AbaRenderer pantalla = new AbaRenderer(nomFitxer, true, null);
               pantalla.load();
               pantalla.renderInterface();	
            
            	///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
               botoAcceptar=(JButton)(pantalla.getObject("acceptar"));
            
               botoAcceptar.addActionListener(
                                    
                                       new ActionListener()
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)
                                          {
                                          
                                             ((JFrame)(pantalla.getObject("errorIdentificacio"))).dispose();
                                          
                                          }
                                       
                                       });
            
            }
            
               catch(Exception e) {
               
                  System.err.println("(ControlIdentificacio4)Error Abacus: " + e.getMessage());
               
               } 
         
         }
      
         op.destructorObjectePersistencia();
         rua.destructorRelacioUsuarisAplicacio();
      
      }
   
   /**
   * Metode que permet a l'usuari finalitzar la sessio en la que esa treballant, d'aquesta manera el seguent
   * usuari s'haura de tornar a identificar si vols accedir a zones especifiques del sistema.
   */
      public void desidentificaUsuari()
      {
      
         usuariActual.desidentifica();
      
         File docFile5 = new File(".././GUI/SGEC_GUI_operacioOK.jar");
         String nomFitxer5 = docFile5.getAbsolutePath();
         JButton acceptar;
      
         try
         {
         
            final AbaRenderer pantalla5 = new AbaRenderer(nomFitxer5, false, null);
            pantalla5.load();
            pantalla5.renderInterface();
         
                                             ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
            acceptar=(JButton)(pantalla5.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                 
                                 
                                    new ActionListener()                 
                                    
                                    
                                    {
                                    
                                    
                                    
                                       public void actionPerformed(ActionEvent ae)       
                                       
                                       
                                       {
                                       
                                          ((JFrame)(pantalla5.getObject("operacioOK"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
         
         
         
            catch(Exception e) {        
            
            
            
               System.err.println("(ControlIdentifiacio5)Error: " + e.getMessage());
            
            }
      
         docFile5 = null;
      
      }
   
   }