   package Entitats.Controladors;

   import java.io.File;
   import javax.swing.*;
   import java.awt.*;
   import java.awt.event.*;
   import ch.abacus.lib.ui.renderer.abaRenderer.AbaRenderer;
   import ch.abacus.lib.ui.renderer.common.jdbc.JSSComboBox;
   import Entitats.Soci.Soci;
   import Entitats.Soci.RelacioSocis;
   import Entitats.Persistencia.ObjectePersistencia;
   import javax.swing.table.DefaultTableColumnModel;
   import javax.swing.table.TableColumn;
   import Entitats.Validadors.ValidadorFormulariEntrada;
   import java.util.Vector;
   import javax.swing.table.AbstractTableModel;
   import javax.swing.table.TableModel;
   import Entitats.Eines.Taula;

/**
* Clase de control. Gestiona el proces que ha de permetre a l'usuari poder fer llistats
* de socis segons uns parametres definits
*@author Jordi Moles i Blanco, Juny 2005
*/

   public class ControlLlistatsSocis
   {
   
      File docFile;
      String nomFitxer;
      AbaRenderer pantalla;
      RelacioSocis relacioSocis;
   
   /**
   * Constructor de la classe. Inicialitza els elements necessaris per tal de poder interactuar 
   * amb la pantalla que ha de permetre a un usuari crear llistats de socis. 
   */
      public ControlLlistatsSocis()
      {
      
         docFile = new File(".././GUI/SGEC_GUI_llistats.jar");
         nomFitxer = docFile.getAbsolutePath();
         docFile = null;
         relacioSocis = new RelacioSocis();
      
      }
   
   /**
   * Destructor de la classe
   * Metode que elimina les referencies als objectes manipulats per l'objecte
   * per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   * quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorControlLlistatsSocis()
      {
      
         pantalla = null;
         relacioSocis.destructorRelacioSocis();
      
      }
   
   /**
   * Metode que instancia i arranca un objecte que conte el frame d'execucio i tots els objectes que el componen
   * com ara textboxs o botons.   
   */
      public void iniciaCreacioLlistat()
      {
      
         try
         {
         
            pantalla = new AbaRenderer(nomFitxer, false, null);
            pantalla.load();
            pantalla.renderInterface();
         
            JButton acceptar,cancelar;
         
            JSSComboBox llistat = (JSSComboBox)pantalla.getObject("llistat");
         
            llistat.addItem("Socis nascuts l'any X",1);
            llistat.addItem("Socis nascuts a partir de l'any X",2);
            llistat.addItem("Socis nascuts abans de l'any X",3);
            llistat.addItem("Socis que es van donar d'alta l'any X",4);
            llistat.addItem("Socis que es van donar d'alta desprs de l'any X",5);
            llistat.addItem("Socis que es van donar d'alta abans de l'any X",6);
            llistat.addItem("Socis actius actualment",7);
         
            llistat.setSelectedValue((long)0);
         
            acceptar=(JButton)(pantalla.getObject("acceptar"));
         
            acceptar.addActionListener(
                                 
                                    new ActionListener()    
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae) 
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("llistats"))).dispose();
                                          long seleccio = ((JSSComboBox)pantalla.getObject("llistat")).getSelectedValue();
                                          creaLlistat((int)seleccio);
                                       
                                       }
                                    
                                    });
         
            cancelar=(JButton)(pantalla.getObject("cancelar"));
         
            cancelar.addActionListener(
                                 
                                    new ActionListener()    
                                    {
                                    
                                       public void actionPerformed(ActionEvent ae) 
                                       {
                                       
                                          ((JFrame)(pantalla.getObject("llistats"))).dispose();
                                       
                                       }
                                    
                                    });
         
         }
            catch(Exception e) {      
            
               System.err.println("(ControlLlistatsSocis1)Error: " + e.getMessage());
            
            }
      
      }
   
      private void creaLlistat(final int llistat)
      {
      
         if(llistat==1 | llistat==2 | llistat==3 | llistat==4 | llistat==5 | llistat==6 | llistat==7)
         {
         
            File docFile2 = new File(".././GUI/SGEC_GUI_any.jar");
            String nomFitxer2 = docFile2.getAbsolutePath();
            JButton acceptar;
         
            try
            {
            
               final AbaRenderer pantalla2 = new AbaRenderer(nomFitxer2, false, null);
               pantalla2.load();
               pantalla2.renderInterface();
            
               ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
               acceptar=(JButton)(pantalla2.getObject("acceptar"));
            
               acceptar.addActionListener(
                                    
                                       new ActionListener()                 
                                       {
                                       
                                          public void actionPerformed(ActionEvent ae)       
                                          {
                                          
                                             String any = ((JTextField)(pantalla2.getObject("valorAny"))).getText();
                                          
                                             if(!ValidadorFormulariEntrada.validaAny(any) & llistat!=7)
                                             {
                                             
                                                File docFile3 = new File(".././GUI/SGEC_GUI_dadesNoValides.jar");
                                                String nomFitxer3 = docFile3.getAbsolutePath();
                                                JButton acceptar;
                                             
                                                try
                                                {
                                                
                                                   final AbaRenderer pantalla3 = new AbaRenderer(nomFitxer3, false, null);
                                                   pantalla3.load();
                                                   pantalla3.renderInterface();
                                                
                                                ///////////BOTO ACCEPTAR\\\\\\\\\\\
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
                                                   acceptar=(JButton)(pantalla3.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                           new ActionListener()                 
                                                                           {
                                                                           
                                                                              public void actionPerformed(ActionEvent ae)       
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla3.getObject("dadesNoValides"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                }
                                                
                                                   catch(Exception e) {        
                                                   
                                                      System.err.println("(ControlLlistatSocis2)Error: " + e.getMessage());
                                                   
                                                   }
                                             
                                                docFile3 = null;
                                             
                                             }
                                             else
                                             {
                                             
                                                ((JFrame)(pantalla2.getObject("any"))).dispose();
                                                if(llistat==1) relacioSocis.obteSociPerAnyNaixement(Integer.parseInt(any));
                                                if(llistat==2) relacioSocis.obteSociPerAnyNaixementAPartirDe(Integer.parseInt(any));
                                                if(llistat==3) relacioSocis.obteSociPerAnyNaixementMenorOIgualQue(Integer.parseInt(any));
                                                if(llistat==4) relacioSocis.obteSociPerAnyIngresEntitat(Integer.parseInt(any));
                                                if(llistat==5) relacioSocis.obteSociPerAnyIngresEntitatAPartirDe(Integer.parseInt(any));
                                                if(llistat==6) relacioSocis.obteSociPerAnyIngresEntitatMenorOIgualQue(Integer.parseInt(any));
                                                if(llistat==7)
                                                {
                                                   ObjectePersistencia DadesSociABuscar = new ObjectePersistencia();
                                                   DadesSociABuscar.afegirCampNumeric("actiu",1);
                                                   relacioSocis.obteSociPerMultiplesCamps(DadesSociABuscar);
                                                }
                                             
                                                File docFile4 = new File(".././GUI/SGEC_GUI_resultatLlistatSociMillorat.jar");
                                                String nomFitxer4 = docFile4.getAbsolutePath();
                                                File docFile5 = new File(".././GUI/SGEC_GUI_noResultats.jar");
                                                String nomFitxer5 = docFile5.getAbsolutePath();
                                                JButton acceptar;
                                             
                                                try
                                                {
                                                
                                                   final AbaRenderer pantalla4 = new AbaRenderer(nomFitxer4, false, null);
                                                   pantalla4.load();
                                                   pantalla4.renderInterface();
                                                
                                                   JTable resultatLlistat = (JTable)(pantalla4.getObject("llista"));
                                                
                                                   Object[][] files = new Object[100][5];
                                                
                                                   Object[] columnes = new Object[]{"Num.Soci","Nom","Cognoms","Data Naixement","Data Alta Ent."};
                                                
                                                   Soci s = new Soci();
                                                   String nom = "";
                                                   String espai = "";
                                                   int posicio = 0;
                                                
                                                   while(relacioSocis.hiHaSocis())
                                                   {
                                                   
                                                      s = relacioSocis.obteSoci();
                                                   
                                                      if(s.esActiu())
                                                      {
                                                      
                                                         files[posicio][0] = ""+s.obteNumSoci()+"";
                                                         files[posicio][1] = s.obteNom();
                                                         files[posicio][2] = s.obteCognom1()+" "+s.obteCognom2();
                                                         files[posicio][3] = s.obteDataNaixement();
                                                         files[posicio][4] = s.obteDataAltaEntitat();
                                                      
                                                      }
                                                      posicio++;
                                                   }
                                                
                                                   s.destructorSoci();
                                                
                                                   Taula dataModel = new Taula(files,columnes);
                                                
                                                   resultatLlistat.setModel(dataModel.obteModel());		
                                                
                                                   acceptar=(JButton)(pantalla4.getObject("acceptar"));
                                                
                                                   acceptar.addActionListener(
                                                                        
                                                                        
                                                                           new ActionListener()    
                                                                           
                                                                           {
                                                                           
                                                                           
                                                                              public void actionPerformed(ActionEvent ae) 
                                                                              
                                                                              {
                                                                              
                                                                                 ((JFrame)(pantalla4.getObject("resultatLlistatSoci"))).dispose();
                                                                              
                                                                              }
                                                                           
                                                                           });
                                                
                                                
                                                
                                                }
                                                
                                                   catch(Exception e) {        
                                                   
                                                   
                                                      System.err.println("(ControlLlistatSocis3)Error: " + e.getMessage());
                                                   
                                                   }
                                             
                                                docFile4 = null;
                                             
                                             }
                                          
                                          }
                                       
                                       });
            
            //si es l'opcio 7, no hem d'entrar res, li donem al acceptar automaticament
               if(llistat==7) acceptar.doClick();
            
            
            }
            
               catch(Exception e) {        
               
                  System.err.println("(ControlLlistatsSocis4)Error: " + e.getMessage());
               
               }
         
            docFile2 = null;
         
         
         }
      
      }
   
   }