   package Entitats.Eines;

   import java.io.*;
   import java.util.zip.*;

   public class CopiaFitxer {
   
      private static int bufferSize = 4 * 1024;
   
      public static Long copia(File srcFile, File destFile)
      throws IOException {
         InputStream in = new FileInputStream(srcFile);
         OutputStream out = new FileOutputStream(destFile);
         CRC32 checksum = null;
      
         checksum = new CRC32();
         checksum.reset();
      
         byte[] buffer = new byte[bufferSize];
         int bytesRead;
         while ((bytesRead = in.read(buffer)) >= 0) {
         
            checksum.update(buffer, 0, bytesRead);
         
            out.write(buffer, 0, bytesRead);
         }
         out.close();
         in.close();
      
         return new Long(checksum.getValue());
      
      }
   
      public static Long creaChecksum(File file) throws IOException {
         InputStream in = new FileInputStream(file);
         CRC32 checksum = new CRC32();
         checksum.reset();
         byte[] buffer = new byte[bufferSize];
         int bytesRead;
         while ((bytesRead = in.read(buffer)) >= 0) {
            checksum.update(buffer, 0, bytesRead);
         }
         in.close();
      
         return new Long(checksum.getValue());
      }
   
   }