   package Entitats.Imatge;

	/**
	* Classe que permet la creacio i manipulacio de imatges 
	* No s'implementa en aquest punt cap validacio de les dades assignades a l'objecte, doncs
	* es creu funcio indispensable de les capes superiors de l'aplicacio, les capes que 
	* utilitzen aquesta classe. 
	*@author Jordi Moles i Blanco, Mar 2005
	*/      

   public class Imatge
   {
   
      private int identificadorImatge; //Valor que identifica la imatge de manera unica
      private String ruta; //Ruta on hem d'anar a buscar la imatge
   
   /**
   *Constructor de la classe.
   *Inicialitza tots els atributs numerics a 0 i els strings a "" (Blanc)
   */
      public Imatge()
      {
      
         identificadorImatge=0;
         ruta="";
      
      }
   
   /**
   *Destructor de la classe
   *Metode que elimina les referencies als objectes manipulats per una imatge
   *per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   *quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorImatge()
      {
      
      
      }
   
   /**
   * Metode que assigna el valor que identifica la imatge de manera unica en el sistema
   *@param identificadorImatge Enter amb el valor de l'identificador de la imatge
   */
      public void estableixIdentificador(int identificadorImatge)
      {
      
         this.identificadorImatge=identificadorImatge;
      
      }
   
   	/**
   	*Metode que assigna la ruta de la imatge.
   	*@param ruta String amb la ruta de la imatge
   	*/
      public void estableixRuta(String ruta)
      {
      
         this.ruta=ruta;
      
      }
   
   /**
   * Metode que obte el valor que identifica la imatge de manera unica en el sistema
   *@return Enter amb el valor de l'identificador
   */
      public int obteIdentificador()
      {
      
         return identificadorImatge;
      
      }
   
   	/**
   	*Metode que obte la ruta on trobar la imatge
   	*@return Un string amb la ruta
   	*/
      public String obteRuta()
      {
      
         return ruta.trim();
      
      }
   
   }