   package Entitats.Participant;

   import Entitats.Soci.Soci;
   import Entitats.Temps.Data;

/**
* Classe que permet la creacio i manipulacio de participants, els quals poden ser usats en qualsevol
* entitat/instutcio que en tingui.
* No s'implementa en aquest punt cap validacio de les dades assignades a l'objecte, doncs
* es creu funcio indispensable de les capes superiors de l'aplicacio, les capes que 
* utilitzen aquesta classe. 
*@author Jordi Moles i Blanco, Agost 2005
*/

   public class Participant extends Soci
   {
   
      private Data dataAltaParticipant;
   
   /**
   *Constructor de la classe.
   *Inicialitza tots els atributs numerics a 0 i els strings a "" (Blanc)
   *La data d'alta com a soci i com a participant s'inicialitzen amb la data que el sistema te 
   *en el moment de la creacio de l'objecte.
   *La data de naixement del soci s'estableix a 00/00/0000
   */
      public Participant()
      {
         super();
         dataAltaParticipant=new Data();
      }
   
   /**
   *Destructor de la classe
   *Metode que elimina les referencies als objectes manipulats per un participant
   *per tal de que l'objecte "Gargabe Collector" del Java n'alliberi la memoria assignada
   *quan descobreixi que l'objecte ja no te cap referencia.
   */
      public void destructorParticipant()
      {
         super.destructorSoci();
         dataAltaParticipant.destructorData();
      }
   
   /**Metode que estableix un valor per a la data d'alta com a participant. 
   *La informacio que hi havia en aquest atribut es perdra de forma definitiva
   *@param dia Enter amb el valor del dia del mes que ha de formar part de la data.
   *@param mes Enter amb el valor del mes de l'any que ha de formar part de la data.
   *@param any Enter amb el valor de l'any que ha de formar part de la data
   */
      public void estableixDataAltaParticipant(int dia,int mes,int any)
      {
         dataAltaParticipant.estableixData(dia,mes,any);
      }
   
   /**
   * Metode que estableix un valor per a la data d'alta com a participant.
   *@param dataAltaParticipant String amb la data d'alta com a participant, en un dels seguents
   *formats: dd/mm/aaaa o dd-mm-aaaa
   */
      public void estableixDataAltaParticipant(String dataAltaParticipant)        
      {
         int dia,mes,any;
         int posicio1,posicio2;
         posicio1=dataAltaParticipant.indexOf("-");
         if(posicio1<0) posicio1=dataAltaParticipant.indexOf("/");
         dia=Integer.parseInt(dataAltaParticipant.substring(0,posicio1));
      
         posicio1++;
         posicio2=dataAltaParticipant.indexOf("-",posicio1);
         if(posicio2<0) posicio2=dataAltaParticipant.indexOf("/",posicio1);
         mes=Integer.parseInt(dataAltaParticipant.substring(posicio1,posicio2));
      
         posicio2++;
         any=Integer.parseInt(dataAltaParticipant.substring(posicio2).trim());
      
         estableixDataAltaParticipant(dia,mes,any);
      
      }
   
   /**
   *Metode per obtenir la data d'alta com a participant
   *@return Un string amb la data completa en format dd/mm/aaaa.
   */ 
      public String obteDataAltaParticipant()                     
      {
         return dataAltaParticipant.obteData().trim();
      
      }
   
   }

