   package Entitats.PropostaModificacioSoci;

   import Entitats.Temps.Data;

/**
* Classe que permet al soci sol.licitar una modificacio de les seves propies dades, ja que aquestes nomes poden ser 
* modificades per un usuari autoritzat
*@author Jordi Moles i Blanco, Juny 2005
*/

   public class PropostaModificacioSoci
   {
   
      private int identificador;
      private String nomSoci;
      private String cognom1Soci;
      private String cognom2Soci;
      private String identificadorPersonalSoci;
      private String adresaSoci;
      private int telefonSoci;
      private Data dataNaixementSoci;
      private int numSoci;
      private boolean actiu;
   
   /* Constructor de la classe */
      public PropostaModificacioSoci()
      {
      
         nomSoci="";
         cognom1Soci="";
         cognom2Soci="";
         identificadorPersonalSoci="";
         adresaSoci="";
         telefonSoci=0;
         dataNaixementSoci = new Data(0,0,0);
      
      }
   
   /* 
   * Metode que estableix l'identificador de la peticio 
   *@param identificador Enter amb el valor d'identificador
   */
      public void estableixIdentificador(int identificador)
      {
      
         this.identificador=identificador;
      
      }
   
   /* 
   * Metode que estableix el nou valor per al nom de la persona 
   *@param nom String amb el nou valor del nom
   */
      public void estableixNom(String nom)
      {
      
         nomSoci = nom;
      
      }
   
   /* 
   * Metode que estableix el nou valor per al primer cognom de la persona 
   *@param cognom1 String amb el nou valor del cognom
   */
      public void estableixCognom1(String cognom1)
      {
      
         cognom1Soci = cognom1;
      
      }
   
   /* 
   * Metode que estableix el nou valor per al segon cognom de la persona 
   *@param cognom2 String amb el nou valor del cognom
   */
      public void estableixCognom2(String cognom2)
      {
      
         cognom2Soci = cognom2;
      
      }
   
   /* 
   * Metode que estableix el nou valor per al identificador de la persona 
   *@param identificadorPersonal String amb el nou valor
   */
      public void estableixIdentificadorPersonal(String identificadorPersonal)
      {
      
         identificadorPersonalSoci = identificadorPersonal;
      
      }
   
   /* 
   * Metode que estableix el nou valor per l'adresa 
   *@param adresa String amb el nou valor
   */
      public void estableixAdresa(String adresa)
      {
      
         adresaSoci = adresa;
      
      }
   
   /* 
   * Metode que estableix el nou valor per al telefon 
   *@param telefon Enter amb el nou valor
   */
      public void estableixTelefon(int telefon)
      {
      
         telefonSoci = telefon;
      
      }
   
   /* 
   * Metode que estableix el nou valor per a la data de naixement 
   *@param dataNaixement String amb el nou valor
   */
      public void estableixDataNaixement(String dataNaixement)
      {
      
         String dia,mes,any;
         int posicio1,posicio2;
      
         posicio1=dataNaixement.indexOf("-");
         if(posicio1<0) posicio1=dataNaixement.indexOf("/");
         any=dataNaixement.substring(0,posicio1);
      
         posicio1++;
         posicio2=dataNaixement.indexOf("-",posicio1);
         if(posicio2<0) posicio2=dataNaixement.indexOf("/",posicio1);
         mes=dataNaixement.substring(posicio1,posicio2);
      
         posicio2++;
         dia=dataNaixement.substring(posicio2).trim();
      
         dataNaixementSoci.estableixData(Integer.parseInt(dia),Integer.parseInt(mes),Integer.parseInt(any));
      
      }
   
   /* 
   * Metode que estableix el nou valor per al numero de soci 
   *@param numSoci Enter amb el nou valor
   */
      public void estableixNumSoci(int numSoci)
      {
      
         this.numSoci = numSoci;
      
      }
   
   /* 
   * Metode que permet obtenir l'identificador de la peticio 
   *@return Enter amb el valor proposat
   */
      public int obteIdentificador()
      {
      
         return identificador;
      
      }
   
   /* 
   * Metode que permet obtenir el nom proposat 
   *@return String amb el valor proposat
   */
      public String obteNom()
      {
      
         return nomSoci;
      
      }
   
   /* 
   * Metode que permet obtenir el primer cognom proposat 
   *@return String amb el valor proposat
   */
      public String obteCognom1()
      {
      
         return cognom1Soci;
      
      }
   
   /* 
   * Metode que permet obtenir el segon cognom proposat 
   *@return String amb el valor proposat
   */
      public String obteCognom2()
      {
      
         return cognom2Soci;
      
      }
   
   /* 
   * Metode que permet obtenir l'identificador proposat 
   *@return String amb el valor proposat
   */
      public String obteIdentificadorPersonal()
      {
      
         return identificadorPersonalSoci;
      
      }
   
   /* 
   * Metode que permet obtenir l'adresa proposada 
   *@return String amb el valor proposat
   */
      public String obteAdresa()
      {
      
         return adresaSoci;
      
      }
   
   /* 
   * Metode que permet obtenir el telefon proposat 
   *@return Enter amb el valor proposat
   */
      public int obteTelefon()
      {
      
         return telefonSoci;
      
      }
   
   /* 
   * Metode que permet obtenir la data de naixement proposada 
   *@return String amb el valor proposat
   */
      public String obteDataNaixement()
      {
      
         return dataNaixementSoci.obteData();
      
      }
   
   /* 
   * Metode que permet obtenir el numero de soci proposat 
   *@return Enter amb el valor proposat
   */
      public int obteNumSoci()
      {
      
         return numSoci;
      
      }
   
   /* 
   * Metode que permet establir una proposta com a activa o no activa 
   *@param actiu Boolean amb valor true o false
   */
      public void estableixActiu(boolean actiu)
      {
      
         this.actiu=actiu;
      
      }
   
   /* 
   * Metode que permet comprovar si una proposta es activa o no 
   *@return Boolean amb l'estat actual de la proposta
   */
      public boolean esActiu()
      {
      
         return actiu;
      
      }
   
   }