   package Entitats.UsuariActual;

/**
* Classe que ens permet mantenir un objecte amb un nom i uns permisos determinats. Aix es de vital importancia, si per exemple, volem disenyar 
* una aplicaci on determinades parts sn d'accs restringit. Amb una instancia d'aquest objecte, que noms pot
* adoptar un rol al mateix temps, podem controlar si en aquell moment l'usuari est autoritzat.
*@author Jordi Moles i Blanco, Maig 2005
*/

   public class UsuariActual
   {
   
      private int nivell;
      private String usuari;
      private String identificador;
   
   /**
   * Constructor de la classe
   */
      public UsuariActual()
      {
      
         nivell = -1;
         usuari = "";
      
      }
   
   /**
   * Metode que ens permet obtenir el nivell actual de l'objecte
   *@return Enter amb el valor del nivell actual
   */
      public int nivellActual()
      {
      
         return nivell;
      
      }
   
   /**
   * Metode que ens permet obtenir el nom de l'usuari en un determinat moment
   *@return String amb el nom d'usuari
   */
      public String usuariActual()         
      {
      
         return usuari;
      
      }
   
   /**
   * Metode que ens permet obtenir l'identificador (password)
   *@return String amb el valor de l'identificador
   */
      public String identificador()
      {
      
         return identificador;
      
      }
   
   /**
   * Metode que ens permet establir el nivell de l'usuari
   *@param nivell Enter amb el nou valor
   */
      public void estableixNivell(int nivell)
      {
      
         this.nivell=nivell;
      
      }
   
   /**
   * Metode que ens permet establir el login de l'usuari
   *@param usuari String amb el nou valor
   */
      public void estableixUsuari(String usuari)              
      {
      
         this.usuari=usuari;
      
      }
   
   /**
   * Metode que ens permet establir el password
   *@param identificador String amb el nou valor
   */
      public void estableixIdentificador(String identificador)
      {
      
         this.identificador=identificador;
      
      }
   
   /**
   * Metode que retira tots els permisos a l'usuari actual, de tal manera que per poder entrar a qualsevol rea restringida,
   *la persona haur de tornar a identificar-se.
   */
      public void desidentifica()
      {
      
         nivell=-1;	
         identificador = "";
         usuari = "";
      
      }
   
   }